Foreman - Bug #22747

Validation on Puppet Class ID When using API
03/01/2018 06:36 PM - lain Walmsley

Status: Closed
Priority: Low
Assignee: lain Walmsley
Category: API
Target version: 1.18.0
Difficulty: easy Fixed in Releases:
Triaged: Found in Releases: Nightly
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/5284
Description

When posting data to;
/api/v2/hosts/:host/puppetclass_ids

The Puppetclass ID is not validated and a successful response is return. While this doesn't cause any issues (it isn't evaluated
against the hosts puppetclasses) it means that errant data can be inserted into the database which can then only be cleaned
manually. It also can be misleading - particuarly when interfacing with external systems which get a positive response.

e.g

# curl -X POST http://localhost:5000/api/v2/hosts/testhost/puppetclass_ids -d '{"puppetclass_id":"
THISISINVALID"}' -H 'Content-Type: application/json'
{"host_id":1, "puppetclass_id":0}

# curl -X POST http://localhost:5000/api/v2/hosts/testhost/puppetclass_ids -d '{"puppetclass_id":"
999999999"}' -H 'Content-Type: application/json'
{"host_id":1, "puppetclass_id":999999999}

Submitting patch to add validation on create action and adding test.

Associated revisions

Revision a8¢c113c0 - 03/05/2018 12:59 PM - lain Walmsley
Fixes #22747 - vet puppetclass_id on addition

History

#1 - 03/01/2018 06:41 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/5284 added

#2 - 03/05/2018 01:01 PM - lain Walmsley
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset a8c113c0d3675144caf51a2c34029¢2a276f3907.

#3 - 03/05/2018 02:08 PM - Daniel Lobato Garcia

- translation missing: en.field_release set to 330
